aboutsummaryrefslogtreecommitdiff
path: root/tools
diff options
context:
space:
mode:
authorPeter Holm <pho@FreeBSD.org>2021-05-26 06:08:56 +0000
committerPeter Holm <pho@FreeBSD.org>2021-05-26 06:08:56 +0000
commit0b5d6b8173d91802cd0d765ce2e19d856f4bc401 (patch)
treefc3eb17772f2bc1382e0501493a07f8e5e72db0e /tools
parentbad9303974fc7e88e34cc6e0f47564ba26517173 (diff)
downloadsrc-0b5d6b8173d91802cd0d765ce2e19d856f4bc401.tar.gz
src-0b5d6b8173d91802cd0d765ce2e19d856f4bc401.zip
stress2: Added a new ptrace() test scenario
Diffstat (limited to 'tools')
-rwxr-xr-xtools/test/stress2/misc/truss2.sh58
1 files changed, 58 insertions, 0 deletions
diff --git a/tools/test/stress2/misc/truss2.sh b/tools/test/stress2/misc/truss2.sh
new file mode 100755
index 000000000000..6a5743550b04
--- /dev/null
+++ b/tools/test/stress2/misc/truss2.sh
@@ -0,0 +1,58 @@
+#!/bin/sh
+
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2021 Peter Holm
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+# Trace random cc, c++ or make threads from a buildkernel
+# Test scenario idea by kib@
+
+old=`sysctl -in kern.kill_on_debugger_exit`
+[ -z "$old" ] && exit 0
+trap "sysctl kern.kill_on_debugger_exit=$old" EXIT INT
+
+# Enable ptrace(2)d processes to continue
+sysctl kern.kill_on_debugger_exit=0
+./buildkernel.sh & kpid=$!
+while true; do
+ for i in `jot 8`; do
+ rpid=`ps -l | grep -vwE 'grep|RE|defunct' | \
+ grep -E "(cc|c\+\+|make) " | \
+ sort -R | head -1 | awk '{print $2}'`
+ [ -n "$rpid" ] && break
+ sleep 1
+ done
+ [ -z "$rpid" ] && break
+ kill -0 $rpid 2>/dev/null || continue
+ ps -lp $rpid | tail -1
+ echo "truss -f -o /dev/null -p $rpid"
+ truss -f -o /dev/null -p $rpid & tpid=$!
+ sleep `jot -r 1 5 10`
+ pkill -9 truss
+ wait $tpid
+done
+wait $kpid
+exit $?